<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers\Admin;
use Illuminate\Http\Request;
use App\Managers\Contact\ContactManager;
use App\Managers\User\UserManager;

use App\Http\Controllers\Controller;


class AdminContactController extends Controller
{
    public function __construct() {
        $this->contactManager = new ContactManager();
        $this->userManager = new UserManager();
    }
    public function index()
    {
        $contact = $this->contactManager->first();
        return view('/admin/contact/update')->with('contact', $contact);
    }
    
    public function update(Request $request)
    {
        if(!$request->all() || !$request->exists('data'))
        {
            return response()->json(['No input found'], 400);
        }
        
       
        $data = $request->get('data');
        
        
        $res = $this->contactManager->where('deleted_at', NULL)->update($data);
        if(!$res)
        {
            return response()->json(['Something Went Wrong'], 500);
            exit;
        }
        
        return response()->json(['Contact Details Updated'], 200);
        exit;
    }
    
    public function notification()
    {
        return view('/admin/notification');
    }
    
    public function sendNotification()
    {
        $email = '';
        $usersCount = $this->userManager->whereDate('created_at', '=', date("Y-m-d"))->count();
        
        
        
        $notificationRequestedUsers = $this->userManager->where('notification',1)->get();
        Mail::send('emails.notifications', ['email' => $user['email'],'url' => url('/'), 'name' => $user['name']], function ($m) use ($user) {
            $m->from('info@realclubmanager.com', 'SUPPORTER 2.0');
            $m->to($user['email'], $user['name'])->subject('SUPPORTER 2.0 - New Decision Proposal');
        });
    }
}