<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers\Admin;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Managers\MailBox\MailBoxManager;
use App\Validators\Admin\AdminMailBoxValidator;
use App\Http\Controllers\Controller;

class AdminMailboxController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->mailBoxManager = new MailBoxManager();
        $this->mailboxValidator = new AdminMailBoxValidator();
    }
    
    public function listMailBox()
    {
        $mails = $this->mailBoxManager->get();
        return view('/admin/mailbox/list')->with('mails', $mails);
    }

    public function addMailBox(Request $request)
    {
        if($request->exists('data'))
        {
            $data = $request->get('data');
            $data['UUID'] = $this->helper->addUuid();

            $validation = $this->mailboxValidator->add($data);

            if($validation)
            {
                return redirect()->back()->withErrors($validation)->withInput();
            }

            $res = $this->mailBoxManager->add($data);
            if(!$res)
            {
                return redirect()->back()->withErrors(array('message' => 'Something went wrong'))->withInput();
            }
            
            return redirect('/admin/mailbox')->withErrors(array('message' => 'Mail Updated Successully'));
        }
        return view('/admin/mailbox/add');
    }

    public function editMailBox(Request $request, $id)
    {
        if(!$data = $this->mailBoxManager->where('UUID', $id)->first())
        {
            return redirect()->back();
            exit;
        }

        if($request->exists('data'))
        {
            $data = $request->get('data');
            $data['UUID'] = $this->helper->addUuid();

            $validation = $this->mailboxValidator->update($data);

            if($validation)
            {
                return redirect()->back()->withErrors($validation)->withInput();
            }

            $res = $this->mailBoxManager->updateData($data, $id);
            if(!$res)
            {
                return redirect()->back()->withErrors(array('message' => 'Something went wrong'))->withInput();
            }
        
            return redirect('/admin/mailbox')->withErrors(array('message' => 'Mail Updated Successully'));
        }

        return view('/admin/mailbox/edit')->with('data', $data);
    }

    public function deleteMailBox($id)
    {
        if(!$mailbox = $this->mailBoxManager->where('UUID', $id)->first())
        {
            return response()->json(['MailBox Not Found'], 500);
        } 
        
        $delete = $this->mailBoxManager->deleteData($id);
        if(!$delete)
        {
            return response()->json(['Something went wrong'], 500);
        }
        
        return response()->json(['MailBox Deleted Successfully'], 200);
    }
}