<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Mail;
use App\Managers\Paypal\PaypalManager;
use App\Managers\Schedule\ScheduleManager;
use App\Managers\User\UserManager;
use App\Managers\Profile\ProfileManager;
use App\Http\Helper\Helper;
use App\Http\Controllers\Controller;

class CronController extends Controller
{
    public function __construct()
    {
    	$this->paypalManager = new PaypalManager();
    	$this->scheduleManager = new ScheduleManager();
    	$this->userManager = new UserManager();
        $this->profileManager = new ProfileManager();
        $this->helper = new Helper();
        $this->profile = $this->profileManager->first();
        if(!$this->profile)
        {
            die("Profile not updated");
        }
    }

    public function voteExpiry()
    {

    	$fiveDaysBefore = date('Y-m-d', strtotime('+' . $this->profile->first_expiry_notification_days_before . ' days'));
    	$threeDaysBefore = date('Y-m-d', strtotime('+' . $this->profile->second_expiry_notification_days_before . ' days'));
        $twoDaysBefore = date('Y-m-d', strtotime('+2 days'));
        $oneDaysBefore = date('Y-m-d', strtotime('+1 days'));
        $oneDayAfterExpiry = date('Y-m-d', strtotime('-1 days'));

    	$paypalFiveDays = $this->paypalManager->with('user')->where('expiry_date', $fiveDaysBefore)->groupBY('user_id')->get();

    	$paypalThreeDays = $this->paypalManager->with('user')->where('expiry_date', $threeDaysBefore)->groupBY('user_id')->get();

        $paypalTwoDays = $this->paypalManager->with('user')->where('expiry_date', $twoDaysBefore)->groupBY('user_id')->get();

        $paypalOneDays = $this->paypalManager->with('user')->where('expiry_date', $oneDaysBefore)->groupBY('user_id')->get();

        $paypalOneDayAfterExpiry = $this->paypalManager->with('user')->where('expiry_date', $oneDayAfterExpiry)->groupBY('user_id')->get();

    	if($paypalFiveDays->count() > 0)
    	{
    		$emailArray = array();
    		foreach($paypalFiveDays AS $paypalFiveDay)
    		{
    			$emailArray[] = $paypalFiveDay->user->email;
    		}

    		if(!empty($emailArray))
    		{
		    	Mail::send('emails.notificationCron.expiringVotes', ['text' => 'view', 'body' => 'Dreptul tau de vot in cadrul www.realclubmanager.com va expira peste 5 zile.<br><br>

Pentru a sustine in continuare activitatea SUPPORTER 2.0, pentru a te bucura in continuare de experienta de MANAGER al clubului si pentru a-ti mentine pozitia in clasamentul fondatorilor acestui proiect, te invitam sa iti prelungesti dreptul de vot printr-o cotizatie de 40 de lei, online, prin transfer bancar sau prin 
                           <form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top">
<input type="hidden" name="cmd" value="_s-xclick" />
<input type="hidden" name="hosted_button_id" value="ZLJJ5Y39KCEU6" />
<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" title="PayPal - The safer, easier way to pay online!" alt="Donate with PayPal button" />
<img alt="" border="0" src="https://www.paypal.com/en_RO/i/scr/pixel.gif" width="1" height="1" />
</form> (pentru plati automate recurente), mai multe detalii pe <a href="http://www.realclubmanager.com/votes">online</a>. Dupa expirarea dreptului de vot, cotizatia minima va fi de 120 de lei pentru un drept de vot valabil 3 luni.    
				
				<br><br>
				
				Va aducem aminte ca 70% din valoarea tuturor cotizatiilor se vor strange in contul public al suporterilor. Valoarea si gestionarea acestuia va depinde de cotizatiile si deciziile noastre. 



', 'url' => url('/')], function($message) use ($emailArray)
		        {  
		            //$message->to('contact@realclubmanager.com');
		            
	               	$message->bcc($emailArray);
		            $message->subject('Expirare drept de vot');    
		        });
		    }
	    }

	    if($paypalThreeDays->count() > 0)
    	{
    		$emailArray = array();
    		foreach($paypalThreeDays AS $paypalThreeDay)
    		{
    			$emailArray[] = $paypalThreeDay->user->email;
    		}
    		if(!empty($emailArray))
    		{
		    	Mail::send('emails.notificationCron.expiringVotes', ['text' => 'view', 'body' => 'Dreptul tau de vot in cadrul www.realclubmanager.com va expira peste 3 zile.<br><br>

Pentru a sustine in continuare activitatea SUPPORTER 2.0, pentru a te bucura in continuare de experienta de MANAGER al clubului si pentru a-ti mentine pozitia in clasamentul fondatorilor acestui proiect, te invitam sa iti prelungesti dreptul de vot printr-o cotizatie de 40 de lei, online, prin transfer bancar sau prin 
                           <form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top">
<input type="hidden" name="cmd" value="_s-xclick" />
<input type="hidden" name="hosted_button_id" value="ZLJJ5Y39KCEU6" />
<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" title="PayPal - The safer, easier way to pay online!" alt="Donate with PayPal button" />
<img alt="" border="0" src="https://www.paypal.com/en_RO/i/scr/pixel.gif" width="1" height="1" />
</form> (pentru plati automate recurente), mai multe detalii pe <a href="http://www.realclubmanager.com/votes">online</a>. Dupa expirarea dreptului de vot, cotizatia minima va fi de 120 de lei pentru un drept de vot valabil 3 luni.    
				
				<br><br>
				
				Va aducem aminte ca 70% din valoarea tuturor cotizatiilor se vor strange in contul public al suporterilor. Valoarea si gestionarea acestuia va depinde de cotizatiile si deciziile noastre. 
', 'url' => url('/')], function($message) use ($emailArray)
		        {  
		           // $message->to('contact@realclubmanager.com');
		            $message->bcc($emailArray);
		            $message->subject('Expirare drept de vot');    
		        });
		    }
	    }

       

        if($paypalOneDays->count() > 0)
        {
            $emailArray = array();
            foreach($paypalOneDays AS $paypalThreeDay)
            {
                $emailArray[] = $paypalThreeDay->user->email;
            }
            if(!empty($emailArray))
            {
                Mail::send('emails.notificationCron.expiringVotes', ['text' => 'view', 'body' => 'Dreptul tau de vot in cadrul www.realclubmanager.com va expira la sfarsitul acestei zile.<br><br>

Pentru a sustine in continuare activitatea SUPPORTER 2.0, pentru a te bucura in continuare de experienta de MANAGER al clubului si pentru a-ti mentine pozitia in clasamentul fondatorilor acestui proiect, te invitam sa iti prelungesti dreptul de vot printr-o cotizatie de 40 de lei, online, prin transfer bancar sau prin 
                           <form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top">
<input type="hidden" name="cmd" value="_s-xclick" />
<input type="hidden" name="hosted_button_id" value="ZLJJ5Y39KCEU6" />
<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" title="PayPal - The safer, easier way to pay online!" alt="Donate with PayPal button" />
<img alt="" border="0" src="https://www.paypal.com/en_RO/i/scr/pixel.gif" width="1" height="1" />
</form> (pentru plati automate recurente), mai multe detalii pe <a href="http://www.realclubmanager.com/votes">online</a>. Dupa expirarea dreptului de vot, cotizatia minima va fi de 120 de lei pentru un drept de vot valabil 3 luni.    
				
				<br><br>
				
				Va aducem aminte ca 70% din valoarea tuturor cotizatiilor se vor strange in contul public al suporterilor. Valoarea si gestionarea acestuia va depinde de cotizatiile si deciziile noastre. 

', 'url' => url('/')], function($message) use ($emailArray)
                {  
                   // $message->to('contact@realclubmanager.com');
                    $message->bcc($emailArray);
                    $message->subject('Expirare drept de vot');    
                });
            }
        }

        if($paypalOneDayAfterExpiry->count() > 0)
        {
            $emailArray = array();
            foreach($paypalOneDays AS $paypalThreeDay)
            {
                $emailArray[] = $paypalThreeDay->user->email;
            }
            if(!empty($emailArray))
            {
                Mail::send('emails.notificationCron.expiringVotes', ['text' => 'view', 'body' => 'Dreptul tau de vot in cadrul www.realclubmanager.com va expira la sfarsitul acestei zile.<br><br>

Pentru a sustine in continuare activitatea SUPPORTER 2.0, pentru a te bucura in continuare de experienta de MANAGER al clubului si pentru a-ti mentine pozitia in clasamentul fondatorilor acestui proiect, te invitam sa iti prelungesti dreptul de vot printr-o cotizatie de 40 de lei, online, prin transfer bancar sau prin 
                           <form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top">
<input type="hidden" name="cmd" value="_s-xclick" />
<input type="hidden" name="hosted_button_id" value="ZLJJ5Y39KCEU6" />
<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" title="PayPal - The safer, easier way to pay online!" alt="Donate with PayPal button" />
<img alt="" border="0" src="https://www.paypal.com/en_RO/i/scr/pixel.gif" width="1" height="1" />
</form> (pentru plati automate recurente), mai multe detalii pe <a href="http://www.realclubmanager.com/votes">online</a>. Dupa expirarea dreptului de vot, cotizatia minima va fi de 120 de lei pentru un drept de vot valabil 3 luni.    
				
				<br><br>
				
				Va aducem aminte ca 70% din valoarea tuturor cotizatiilor se vor strange in contul public al suporterilor. Valoarea si gestionarea acestuia va depinde de cotizatiile si deciziile noastre. 
				
', 'url' => url('/')], function($message) use ($emailArray)
                {  
                   // $message->to('contact@realclubmanager.com');
                    $message->bcc($emailArray);
                    $message->subject('Expirare drept de vot');    
                });
            }
        }
    }

    public function lineup()
    {

    	$fiveHoursAfter = date('Y-m-d H:i:s', strtotime('+' . $this->profile->match_notification_hours_before . ' hours'));
    	$schedules = $this->scheduleManager->with('pre_formation', 'opposite_team_det')->where('start_time' , '<=', $fiveHoursAfter)->where('start_time', '>=', date("Y-m-d H:i:s"))->get();
    	$users = $this->userManager->where('active', 1)->where('notification', 1)->get();

    	foreach($schedules AS $schedule)
    	{
    		$emailArray = array();
    		foreach($users AS $user)
    		{
    			$emailArray[] = $user->email;
    		}
    		if(!empty($emailArray))
    		{
		    	Mail::send('emails.notificationCron.startingLineUpNotification', ['text' => 'view', 'schedule' => $schedule, 'url' => url('/')], function($message) use ($emailArray)
		        {  
		           // $message->to('contact@realclubmanager.com');
		            $message->bcc($emailArray);
		            $message->subject('Zi de meci. Propune echipa de start!');    
		        });
		    }
    	}
    }

    public function getFirstManagerCount()
    {
        $users = $this->paypalManager->select('users.*', 'paypal.expiry_date', 'paypal.created_at AS payment_created_at')->join('users', 'users.UUID', '=', 'paypal.user_id')->where('users.active', 1)->where('paypal.expiry_date', '>=', date("Y-m-d"))->groupBY('users.UUID')->orderBy('paypal.created_at')->get();
        $count = 1;
        foreach($users AS $user)
        {
            $data['payment_count'] = $count++;
            $this->userManager->where('UUID', $user->UUID)->update($data);
        }
    }
}