<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateSubpositionTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('subposition', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->uuid('UUID')->unique();
            $table->string('name');
            $table->uuid('position_id');
            $table->uuid('user_id');
            $table->timestamps();
            
            $table->softDeletes();
            
            $table->foreign('user_id')->references('UUID')->on('users');
            $table->foreign('position_id')->references('UUID')->on('position');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('subposition');
    }
}
