<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateTransactionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('transactions', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->uuid('UUID')->unique();

            $table->string('title', 1000)->nullable();
            $table->text('description')->nullable();
            $table->boolean('credit')->default(1);
            $table->decimal('amount')->default(0.00);
            $table->uuid('user_id');
            $table->timestamps();
            
            $table->softDeletes();

            $table->foreign('user_id')->references('UUID')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('transactions');
    }
}
